﻿Type=Activity
Version=1.70
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
Sub Globals
'	These global variables will be redeclared each time the activity is created.
'	These variables can only be accessed from this module.
	Dim btnNext2 As Button
	Dim editText1 As EditText
	Dim edittext2 As EditText
	Dim edittext3 As EditText
	Dim edittext4 As EditText
	Dim edittext5 As EditText
	Dim button5 As Button
	Dim d1 As Double, d2 As Double
	Dim NegD1 As Double, NegDd2 As Double
	Dim L1 As Double, K1 As Double
	Dim L2 As Double, K2 As Double
	Dim CND1 As Double, CND2 As Double
	Dim BlackScholes As Double
	Dim a1 As Double
	Dim a2 As Double 
	Dim a3 As Double
	Dim a4 As Double
	Dim a5 As Double
	Dim T1 As Double
	Dim v1 As Double
	Dim r1 As Double
End Sub
 
Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Put")
End Sub
 
Sub Activity_Resume

End Sub
 
Sub Activity_Pause (UserClosed As Boolean)

End Sub
 
Sub btnNext2_Click
	StartActivity(Main)
End Sub

Sub btnNext3_click
	StartActivity(Call)
End Sub

Sub button5_click 
'	The Black and Scholes (1973) Stock option formula
	a1 = 0.31938153
	a2 = -0.356563782
	a3 = 1.781477937
	a4 = -1.821255978
	a5 = 1.330274429

	S = edittext1.Text : ' Stock price
	X = edittext2.Text : ' Strike price
	T = edittext4.Text : ' Years to maturity
	r = edittext3.Text : ' Risk-free rate
	v = edittext5.Text : ' Volatility
	
	T1 = T / 365


	D1 = (Logarithm(S / X, cE) + (r + (Power(v, 2)/2) * T1)) / (v * Sqrt(T1))
	D2 = D1 - v * Sqrt(T1)
	
	NegD1 = - D1
	NegD2 = - D2
	
		L1 = Abs(NegD1)
		K1 = 1 / (1 + 0.2316419 * L1)
		CND1 = 1 - 1 / Sqrt(2 * 3.14159) * Power(cE,(-Power(L1 , 2) / 2)) * (a1 * K1 + a2 * Power(K1, 2) + a3 * Power(K1, 3) + a4 * Power(K1, 4) + a5 * Power(K1, 5))
	
			If NegD1 < 0 Then
				CND1 = 1 - CND1
			End If

		L2 = Abs(NegD2)
		K2 = 1 / (1 + 0.2316419 * L2)
		CND2 = 1 - 1 / Sqrt(2 * 3.14159) * Power(cE,(-Power(L2 , 2) / 2)) * (a1 * K2 + a2 * Power(K2, 2) + a3 * Power(K2, 3) + a4 * Power(K2, 4) + a5 * Power(K2, 5))
	
			If NegD2 < 0 Then
				CND2 = 1 - CND2
			End If
	
	BlackScholes = - S * CND1 + X * Power(cE, -r * T) * CND2
		
	Msgbox(" " & Blackscholes & " ", "Black and Scholes Put Option:")
End Sub
